Subject: Re: bug#50950: "(emacs) Mark" should contrast to "selecting" text in other editors

From: Eli Zaretskii <[email-masked]>
Date: Sat, 02 Oct 2021 09:22:41 +0300

> From: Stefan Kangas <[email-masked]>
> Date: Sat, 2 Oct 2021 01:01:21 +0200
> Cc: [email-masked]
> 
> > I disagree that the region is a basic feature.  It may look
> > deceptively similar to text selections, but it isn't.  We have the
> > region, the active region, and the shift- and mouse-selected text,
> > which all look similar, and sometimes behave similarly, but they are
> > not identical.
> 
> IMO, it is not an advanced feature, and on the most basic level it
> really is just selecting text.  You want to copy it, make it bold,
> indent it, or what have you.
> 
> It is of course precisely what makes it different that needs to be
> explained.  But this can and IMO should be done by starting out from
> what is already known.  For example, where we now have:
> 
>   Many Emacs commands operate on an arbitrary contiguous part of the
>   current buffer.  To specify the text for such a command to operate on,
>   you set “the mark” at one end of it, and move point to the other end.
> 
> it would be better to put something along these lines:
> 
>   In other text editors, you can select text to perform various
>   operations on, such as copying or deleting it.  In Emacs, we say
>   that such commands operate on the "region".
> 
>   The region starts at point, and ends at what in Emacs is known
>   as "the mark" ...
> 
>   [Note: this a very quick write-up, and not a proposal.]
> 
> We don't need to talk about "arbitrary contiguous parts" or anything
> like that.  There is no need to pretend as if the user don't already
> have a very strong concept of what exactly is a text selection and how
> it works: our job is to help the user see exactly where that intuition
> fails.

As I said, rewriting this overview text is probably a good idea, so no
argument here.  But the new text should still explain how our region
is different in subtle but important ways from what people see in
other editors.  Would you like to propose such a rewording?

> In any case, AFAICT, the manual doesn't make much of an attempt to
> explain this difference as it is, so I'm not sure it is very
> important.

I think it is important to explain; the fact that we don't is just
because once upon a time there was just one kind of region, and other
applications at that time didn't have anything even close.  Nowadays
things are different, so the way the overview is presented needs to be
rethought.